/*
 * blancoDb
 * Copyright (C) 2005 Tosiki Iga
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 */
package blanco.db.expander.query.caller;

import java.util.Iterator;

import blanco.db.definition.QueryCaller;
import blanco.db.mapping.BlancoDbMappingUtil;
import blanco.db.util.BlancoDbObjectStorage;
import blanco.db.util.BlancoDbQueryParserUtil;
import blanco.ig.expander.Type;
import blanco.ig.expander.Value;
import blanco.ig.expander.implementor.Implementor;
import blanco.ig.expander.method.MethodExpander;

/**
 * @author tosiki iga
 */
public class PrepareCallMethod2 extends MethodExpander {
    BlancoDbObjectStorage storage = null;

    private QueryCaller _caller = null;

    private Value queryArgument = new Value(String.class, "query");

    public PrepareCallMethod2(final BlancoDbObjectStorage storage,
            final QueryCaller caller) {
        super("prepareCall");
        this.storage = storage;
        _caller = caller;
    }

    public void setupSignature() {
        // 引数を追加してみる。
        addArgument(queryArgument);

        getJavaDoc().addException(new Type("java.sql.SQLException"),
                "SQL例外が発生した場合。");
        addException(new Type("java.sql.SQLException"));

        getJavaDoc().addLine("与えられたSQL文をもちいてプリコンパイルを実施(動的SQL)します。");
        getJavaDoc().addLine("");
        getJavaDoc().addLine(
                "動的に内容が変化するようなSQLを実行する必要がある場合にのみ、こちらのメソッドを利用します。<br>");
        getJavaDoc()
                .addLine(
                        "そうではない場合には、このメソッドの利用は避けて prepareCall()メソッド (引数なし)を呼び出してください。<br>");
        getJavaDoc()
                .addLine(
                        "なぜなら、このメソッドではSQL文そのものをパラメータとして与えることができて自由度が高い一方、SQLインジェクションと呼ばれるセキュリティホールが発生する可能性を引き起こしてしまうからです。<br>");
        getJavaDoc().addLine("内部的にConnection.prepareCallを呼び出します。<br>");

        getJavaDoc().addParameter("query",
                "プリコンパイルを実施させたいSQL文。動的SQLの場合には、この引数には加工された後の実行可能なSQL文を与えます。");
    }

    public void implement() {
        final Implementor implementor = new Implementor(getData());

        if (storage.getSetting().isLogging()) {
            implementor.addLine("if (fLog.isDebugEnabled()) {");
            implementor.addLine("fLog.debug(\"" + getName()
                    + ": query = \" + query);");
            implementor.addLine("}");
            implementor.addLine("");
        }

        implementor.addStatement("close()");

        implementor.addStatement("fStatement = fConnection.prepareCall(query)");

        final BlancoDbQueryParserUtil query = new BlancoDbQueryParserUtil(
                _caller.getQuery());

        final Iterator ite = _caller.getOutParameterIterator();
        while (ite.hasNext()) {
            // 現状、とりあえず与えられた順序で登場と仮定が加わっています。
            final Value val = (Value) ite.next();

            final int[] listCol = query.getSqlParameters(val.getName());
            if (listCol == null) {
                System.out.println("[" + _caller.getName() + "]の SQL出力パラメータ["
                        + val.getName() + "]が結びついていません.");
                continue;
            }
            for (int iteSame = 0; iteSame < listCol.length; iteSame++) {
                final int index = listCol[iteSame];

                String stmtLine = "fStatement.registerOutParameter("
                        + index
                        + ", "
                        + BlancoDbMappingUtil.convertJavaTypeToJdbcType(val
                                .getType().getFullName());
                stmtLine += ")";
                implementor.addStatement(stmtLine);
            }
        }
    }
}